# check which direction the block should slide
# @s = puzzle block marker
# at @s
# run from block_movement

# if caught by chain play sound and stop movement
execute if predicate gm4_puzzle_block:puzzle_blocks/held_by_chain run scoreboard players set @s gm4_pb_auto_move 0
execute if predicate gm4_puzzle_block:puzzle_blocks/held_by_chain run playsound minecraft:block.chain.place block @a ~ ~1 ~ 1 0.6

execute if score @s gm4_pb_auto_move matches 1 if predicate gm4_puzzle_block:puzzle_blocks/east_push_check run function gm4_puzzle_block:mechanic/ice/east_propagate
execute if score @s[scores={gm4_pb_moving=0}] gm4_pb_auto_move matches 2 if predicate gm4_puzzle_block:puzzle_blocks/north_push_check run function gm4_puzzle_block:mechanic/ice/north_propagate
execute if score @s[scores={gm4_pb_moving=0}] gm4_pb_auto_move matches 3 if predicate gm4_puzzle_block:puzzle_blocks/south_push_check run function gm4_puzzle_block:mechanic/ice/south_propagate
execute if score @s[scores={gm4_pb_moving=0}] gm4_pb_auto_move matches 4 if predicate gm4_puzzle_block:puzzle_blocks/west_push_check run function gm4_puzzle_block:mechanic/ice/west_propagate

# if movement was blocked by a crate transfer momentum
tag @s add gm4_target
execute if score @s[scores={gm4_pb_moving=0}] gm4_pb_auto_move matches 1 positioned ~1 ~ ~ as @e[type=marker,tag=gm4_pb_block.crate,distance=..0.1] if block ~ ~-1 ~ #gm4_puzzle_block:ice run function gm4_puzzle_block:mechanic/ice/transfer_to_crate
execute if score @s[scores={gm4_pb_moving=0}] gm4_pb_auto_move matches 2 positioned ~ ~ ~-1 as @e[type=marker,tag=gm4_pb_block.crate,distance=..0.1] if block ~ ~-1 ~ #gm4_puzzle_block:ice run function gm4_puzzle_block:mechanic/ice/transfer_to_crate
execute if score @s[scores={gm4_pb_moving=0}] gm4_pb_auto_move matches 3 positioned ~ ~ ~1 as @e[type=marker,tag=gm4_pb_block.crate,distance=..0.1] if block ~ ~-1 ~ #gm4_puzzle_block:ice run function gm4_puzzle_block:mechanic/ice/transfer_to_crate
execute if score @s[scores={gm4_pb_moving=0}] gm4_pb_auto_move matches 4 positioned ~-1 ~ ~ as @e[type=marker,tag=gm4_pb_block.crate,distance=..0.1] if block ~ ~-1 ~ #gm4_puzzle_block:ice run function gm4_puzzle_block:mechanic/ice/transfer_to_crate
tag @s remove gm4_target

# cancel ice movement if it was blocked
execute unless score @s gm4_pb_moving matches 1.. run scoreboard players set @s gm4_pb_auto_move 0

# if movement was blocked check for other possible movements, if one is found pause movement for a tick
execute unless score @s gm4_pb_auto_move matches 1.. at @s if data entity @e[type=block_display,tag=gm4_pb_replace_display,limit=1,sort=nearest,distance=..0.2] block_state{Name:"minecraft:birch_trapdoor",Properties:{half:"top",open:"false"}} run scoreboard players set @s gm4_pb_auto_move 5
execute unless score @s gm4_pb_auto_move matches 1.. at @s if data entity @e[type=block_display,tag=gm4_pb_replace_display,limit=1,sort=nearest,distance=..0.2] block_state{Name:"minecraft:birch_trapdoor",Properties:{facing:"east",half:"bottom",open:"false"}} run scoreboard players set @s gm4_pb_auto_move 6
execute unless score @s gm4_pb_auto_move matches 1.. at @s if data entity @e[type=block_display,tag=gm4_pb_replace_display,limit=1,sort=nearest,distance=..0.2] block_state{Name:"minecraft:birch_trapdoor",Properties:{facing:"north",half:"bottom",open:"false"}} run scoreboard players set @s gm4_pb_auto_move 7
execute unless score @s gm4_pb_auto_move matches 1.. at @s if data entity @e[type=block_display,tag=gm4_pb_replace_display,limit=1,sort=nearest,distance=..0.2] block_state{Name:"minecraft:birch_trapdoor",Properties:{facing:"south",half:"bottom",open:"false"}} run scoreboard players set @s gm4_pb_auto_move 8
execute unless score @s gm4_pb_auto_move matches 1.. at @s if data entity @e[type=block_display,tag=gm4_pb_replace_display,limit=1,sort=nearest,distance=..0.2] block_state{Name:"minecraft:birch_trapdoor",Properties:{facing:"west",half:"bottom",open:"false"}} run scoreboard players set @s gm4_pb_auto_move 9
execute if score @s[scores={gm4_pb_moving=0}] gm4_pb_auto_move matches 1.. run scoreboard players set @s gm4_pb_moving 1

execute unless score $advancement.ice gm4_pb_data matches 1 run function gm4_puzzle_block:technical/advancements/ice
