# move puzzle block to this location
# @s = puzzle block marker
# at @s | positioned ~x ~x ~x
# run from mechanic/move/east | positioned ~1 ~ ~
# run from mechanic/move/north | positioned ~ ~ ~-1
# run from mechanic/move/south | positioned ~ ~ ~1
# run from mechanic/move/west | positioned ~-1 ~ ~
# run from mechanic/gravity/apply | positioned ~ ~-1 ~
# run from mechanic/piston/apply/down | positioned ~ ~-1 ~
# run from mechanic/piston/apply/up | positioned ~ ~1 ~
# run from mechanic/elevator/apply | positioned ~ ~1 ~
# run from mechanic/reset/block_up | positioned ~ ~1 ~
# run from mechanic/reset/block | positioned ~ ~ ~
# run from mechanic/undo/restore/block | positioned ~ ~ ~

# tag as having been pushed
tag @s add gm4_pb_block.pushed

# chain sound
execute if predicate gm4_puzzle_block:puzzle_blocks/held_by_chain run playsound minecraft:block.chain.place block @a ~ ~ ~ 1 0.9

# waterlogging
execute if block ~ ~ ~ water[level=0] run tag @s add gm4_pb_puzzle_waterlogged
execute if block ~ ~ ~ #gm4_puzzle_block:allow_pushing_into[waterlogged=true] run tag @s add gm4_pb_puzzle_waterlogged
# will also be added for seagrass

# check for auto move (conveyor, elevator)
execute unless score @s gm4_pb_auto_move matches 1.. if block ~ ~ ~ birch_trapdoor[half=top,open=false] run scoreboard players set @s gm4_pb_auto_move 5
execute unless score @s gm4_pb_auto_move matches 1.. if block ~ ~ ~ birch_trapdoor[facing=east,half=bottom,open=false] run scoreboard players set @s gm4_pb_auto_move 6
execute unless score @s gm4_pb_auto_move matches 1.. if block ~ ~ ~ birch_trapdoor[facing=north,half=bottom,open=false] run scoreboard players set @s gm4_pb_auto_move 7
execute unless score @s gm4_pb_auto_move matches 1.. if block ~ ~ ~ birch_trapdoor[facing=south,half=bottom,open=false] run scoreboard players set @s gm4_pb_auto_move 8
execute unless score @s gm4_pb_auto_move matches 1.. if block ~ ~ ~ birch_trapdoor[facing=west,half=bottom,open=false] run scoreboard players set @s gm4_pb_auto_move 9
execute unless score @s gm4_pb_auto_move matches 1.. if block ~ ~-1 ~ lightning_rod[facing=south] run scoreboard players set @s gm4_pb_auto_move 6
execute unless score @s gm4_pb_auto_move matches 1.. if block ~ ~-1 ~ lightning_rod[facing=east] run scoreboard players set @s gm4_pb_auto_move 7
execute unless score @s gm4_pb_auto_move matches 1.. if block ~ ~-1 ~ lightning_rod[facing=west] run scoreboard players set @s gm4_pb_auto_move 8
execute unless score @s gm4_pb_auto_move matches 1.. if block ~ ~-1 ~ lightning_rod[facing=north] run scoreboard players set @s gm4_pb_auto_move 9

# store block to be replaced in score to skip unneeded checks
execute unless score @s gm4_pb_replace_block matches 1.. if block ~ ~ ~ #gm4_puzzle_block:requires_replacement run function gm4_puzzle_block:mechanic/move/store_block

# move block
summon item_display ~ ~ ~ {view_range:0.625f,Tags:["gm4_pb_block_display","gm4_pb_block_display.air"],transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[-.0005f,-.0005f,-.0005f],scale:[1.001f,1.001f,1.001f]},item:{id:"minecraft:air"}}
execute if entity @s[tag=!gm4_pb_puzzle_waterlogged] run setblock ~ ~ ~ dark_oak_leaves[persistent=false]
execute if entity @s[tag=gm4_pb_puzzle_waterlogged] run setblock ~ ~ ~ dark_oak_leaves[waterlogged=true,persistent=false]
tp @s ~ ~ ~

# magnet beams
execute if entity @e[type=item_display,tag=gm4_pb_magnet.beam,distance=..0.3] as @e[type=slime,tag=gm4_pb_magnet] if predicate gm4_puzzle_block:puzzle_blocks/magnet_in_range run tag @s add gm4_pb_magnet.rebeam

# tag nearby blocks
execute at @s run tag @e[type=marker,tag=gm4_pb_block,distance=..1.75] add gm4_pb_block.move_check

# recheck this block if it's a lamp (making sure this happens in edge cases)
tag @s remove gm4_pb_block.lamp.checked
